from math import sqrt
import matplotlib.pyplot as plt

h0 = 1.6         # m , altura inicial
v = 0.0          # m/s, velocitat actual
g = 9.81         # m/s2  , acceleracio gravetat
t = 0.0          # temps inicial
dt = 0.001       # increment de temps
rho = 0.65       # coeficient de restitucio = V1 (velocitat despres del xoc ) / V0 (Velocitat abans del xoc)
tau = 0.01       # temps de contacte al bot
hmax = h0        # altura maxima
h = h0
hstop = 0.01   # atura quan el bot es menor que 1 cm
freefall = True # estat: freefall (caiguda lliure) o en contacte
t_last = -sqrt(2*h0/g) # temps al qual hem llanssat per assolir h0 en t=0
vmax = sqrt(2 * hmax * g) # Vmax treta pel principi de conservacio energia , Ec = Ep
H = [] # Matriu altura
T = [] # Matriu temps
comptador = 0  # Comptarem els bots que fa la boleta
while(hmax > hstop):
    if(freefall): # Esten en caigua lliure
        hnew = h + v*dt - 0.5*g*dt*dt
        if(hnew<0): # Fa contacte la boleta
            t = t_last + 2*sqrt(2*hmax/g) 
            freefall = False
            t_last = t + tau
            h = 0
            
        else: # La boleta esta pujant o baixant. El temps corre.
            t = t + dt
            v = v - g*dt
            h = hnew
    else: # Engeguem un nou bot
        t = t + tau 
        vmax = vmax * rho
        v = vmax
        freefall = True
        print ("Bot numero =", comptador)
        print("hmax =", hmax)
        print("bot aturat per a t=%.3f\n"%(t))
        comptador = comptador +1
        h = 0
    hmax = 0.5*vmax*vmax/g # Del principi de conservacio Energia (Ec=Ep) deduim hmax. 
    H.append(h) # Afegim un valor de h (altura) nou a la matriu
    T.append(t) # Afegim un valor de t (temps) nou a la matriu


plt.figure()
plt.grid(True, ls = '-', color= '0.9')
plt.plot(T, H)
plt.xlabel('Temps')
plt.ylabel('Altura')
plt.title('Boleta botant')
plt.show()
